(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types'), require('styled-components')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types', 'styled-components'], factory) :
  (factory((global.reactGridFlexbox = {}),global.React,global.PropTypes,global.styled));
}(this, (function (exports,React,PropTypes,styled) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;
  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  styled = styled && styled.hasOwnProperty('default') ? styled['default'] : styled;

  var composeCSSMedia = function composeCSSMedia(cssProp, value, defaultValue) {
    var parseValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function (_value) {
      return _value;
    };

    var defaultBreakpoints = {
      tn: '0px', xs: '500px', sm: '768px', md: '992px',
      lg: '1200px', xl: '1440px', hg: '1920px'
    };

    if (typeof value === 'string') {
      console.log(value, 'is string');
      return cssProp + ': ' + parseValue(value) + ';';
    } else if (value === Object(value)) {
      console.log(value, 'is object');
      return Object.keys(value).reduce(function (mediaString, key) {
        return '\n      ' + mediaString + '\n      @media (min-width: ' + (defaultBreakpoints[key] ? defaultBreakpoints[key] : key) + ') {\n        ' + cssProp + ': ' + parseValue(value[key]) + ';\n      }\n    ';
      }, '');
    }
    return defaultValue ? cssProp + ': ' + parseValue(defaultValue) + ';' : '';
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var taggedTemplateLiteral = function (strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  };

  var _templateObject = taggedTemplateLiteral(['\n    ', '\n  '], ['\n    ', '\n  ']),
      _templateObject2 = taggedTemplateLiteral(['\n    display: grid;\n    ', '\n    ', '\n    ', '\n    ', '\n    ', '\n  '], ['\n    display: grid;\n    ', '\n    ', '\n    ', '\n    ', '\n    ', '\n  ']);

  var GridChild = function GridChild(_ref) {
    var children = _ref.children,
        _area = _ref._area;

    var StyledGridChild = styled.div(_templateObject, composeCSSMedia('grid-area', _area, 'auto'));

    return React.createElement(
      StyledGridChild,
      null,
      children
    );
  };

  GridChild.propTypes = {
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    _area: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]).isRequired
  };

  var Grid = function Grid(_ref2) {
    var className = _ref2.className,
        children = _ref2.children,
        columns = _ref2.columns,
        rows = _ref2.rows,
        areas = _ref2.areas,
        gutter = _ref2.gutter,
        container = _ref2.container;

    var StyledGrid = styled.div(_templateObject2, composeCSSMedia('grid-template-columns', columns, 'auto'), composeCSSMedia('grid-template-rows', rows, 'auto'), composeCSSMedia('grid-template-areas', areas), composeCSSMedia('grid-gap', gutter), container ? composeCSSMedia('padding', gutter) : '');

    var gridChildren = React.Children.map(children, function (child) {
      if (child) {
        var gridChildProps = {
          '_area': child.props._area
        };

        var childPropsWithoutGridProps = Object.assign({}, child.props);

        Object.keys(gridChildProps).forEach(function (key) {
          delete childPropsWithoutGridProps[key];
        });

        var wrapped = React.createElement('div', gridChildProps, Object.assign({}, child, {
          props: childPropsWithoutGridProps
        }));

        return React.createElement(GridChild, wrapped.props);
      }
      return null;
    });
    return className ? React.createElement(
      'div',
      { className: className },
      React.createElement(
        StyledGrid,
        null,
        gridChildren
      )
    ) : React.createElement(
      StyledGrid,
      null,
      gridChildren
    );
  };

  Grid.propTypes = {
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    className: PropTypes.string,
    columns: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    rows: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    areas: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]).isRequired,
    gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    container: PropTypes.bool
  };

  Grid.defaultProps = {
    className: null,
    columns: 'auto',
    rows: 'auto',
    gutter: '0px',
    container: false
  };

  var _templateObject$1 = taggedTemplateLiteral(['\n    padding: calc(', ' / 2);\n    ', '\n    ', ' \n    ', '\n    ', '\n  '], ['\n    padding: calc(', ' / 2);\n    ', '\n    ', ' \n    ', '\n    ', '\n  ']),
      _templateObject2$1 = taggedTemplateLiteral(['\n    display: flex;\n    align-content: flex-start;\n    flex-direction: ', ';\n    flex-wrap: ', ';\n    ', '\n    ', '\n    ', '\n\n    > * {\n      max-width: 100%;\n    }\n  '], ['\n    display: flex;\n    align-content: flex-start;\n    flex-direction: ', ';\n    flex-wrap: ', ';\n    ', '\n    ', '\n    ', '\n\n    > * {\n      max-width: 100%;\n    }\n  ']);

  var FlexChild = function FlexChild(_ref) {
    var className = _ref.className,
        children = _ref.children,
        _grow = _ref._grow,
        _basis = _ref._basis,
        _reset = _ref._reset,
        _scroll = _ref._scroll,
        gutter = _ref.gutter,
        inline = _ref.inline;

    console.log(gutter);
    var StyledFlexChild = styled.div(_templateObject$1, gutter, _grow ? 'flex-grow: 1;' : '', _basis ? composeCSSMedia('flex-basis', _basis, 'auto') : '', _scroll ? '\n      > * {\n        ' + composeCSSMedia('max-width', gutter, '0px', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n        ' + composeCSSMedia('max-heigth', gutter, '0px', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n        overflow: auto;\n      }\n    ' : '', !inline && _grow && _reset ? '\n      position: relative;\n      > * {\n        position: absolute;\n        ' + composeCSSMedia('width', gutter, '0px', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n        ' + composeCSSMedia('height', gutter, '0px', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n      }\n    ' : '');

    var renderChildWithClassName = function renderChildWithClassName() {
      return className ? React.createElement(
        'div',
        { className: className },
        children
      ) : children;
    };

    return _reset || _scroll ? React.createElement(
      StyledFlexChild,
      null,
      React.createElement(
        'div',
        null,
        renderChildWithClassName()
      )
    ) : React.createElement(
      StyledFlexChild,
      null,
      renderChildWithClassName()
    );
  };

  FlexChild.propTypes = {
    className: PropTypes.string,
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    _grow: PropTypes.bool,
    _basis: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    _reset: PropTypes.bool,
    _scroll: PropTypes.bool,
    inline: PropTypes.bool,
    gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)])
  };

  FlexChild.defaultProps = {
    className: null,
    _grow: false,
    _reset: false,
    _scroll: false,
    _basis: null,
    inline: false,
    gutter: '0px'
  };

  var Flex = function Flex(_ref2) {
    var className = _ref2.className,
        children = _ref2.children,
        inline = _ref2.inline,
        wrap = _ref2.wrap,
        itemsCenter = _ref2.itemsCenter,
        fullHeight = _ref2.fullHeight,
        container = _ref2.container,
        gutter = _ref2.gutter;

    var StyledFlex = styled.div(_templateObject2$1, inline ? 'row' : 'column', wrap && inline ? 'wrap' : 'nowrap', itemsCenter ? 'align-items: center;' : '', fullHeight ? 'min-height: 100%;' : '', container ? '\n      margin: 0;\n      ' + composeCSSMedia('padding', gutter, null, function (value) {
      return 'calc(' + value + ' / 2)';
    }) + '\n    ' : '\n      ' + composeCSSMedia('margin', gutter, null, function (value) {
      return 'calc(-' + value + ' / 2)';
    }) + '\n    ');

    var flexChildren = React.Children.map(children, function (child) {
      // Wrap any children in a div to prevent potential css flex layout overrides.
      if (child) {
        var flexChildProps = Object.keys(FlexChild.defaultProps).reduce(function (props, key) {
          if (key !== 'className') {
            props[key] = child.props[key];
          }
          return props;
        }, {});

        var childPropsWithoutFlexProps = Object.assign({}, child.props);

        Object.keys(flexChildProps).forEach(function (key) {
          delete childPropsWithoutFlexProps[key];
        });

        var wrapped = React.createElement('div', flexChildProps, Object.assign({}, child, {
          props: childPropsWithoutFlexProps
        }));

        return React.createElement(FlexChild, _extends({}, wrapped.props, { gutter: gutter, isInline: inline }));
      }
      return null;
    });

    return className ? React.createElement(
      'div',
      { className: className },
      React.createElement(
        StyledFlex,
        null,
        flexChildren
      )
    ) : React.createElement(
      StyledFlex,
      null,
      flexChildren
    );
  };

  Flex.propTypes = {
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    className: PropTypes.string,
    inline: PropTypes.bool,
    wrap: PropTypes.bool,
    itemsCenter: PropTypes.bool,
    fullHeight: PropTypes.bool,
    container: PropTypes.bool,
    gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)])
  };

  Flex.defaultProps = {
    className: null,
    inline: false,
    wrap: false,
    itemsCenter: false,
    fullHeight: false,
    container: false,
    gutter: '0px'
  };

  exports.Grid = Grid;
  exports.Flex = Flex;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
